{*************************************************
 * Demo3                                         *
 *                                               *
 * This sample, like in the Demo2, outline       *
 * a simple acounting application, but in        *
 * addition shows how to create a customized     *
 * registration form.                            *
 *                                               *
 *     Part of the AVLock PRO package            *
 *     (c) Alcides Valega, 2004                  *
 *************************************************}

unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, stdctrls, AVLock3Pro, jpeg, ExtCtrls, shellapi;

type
  TForm1 = class(TForm)
    MM1: TMainMenu;
    Archivos1: TMenuItem;
    Registration1: TMenuItem;
    Salir1: TMenuItem;
    Modulo11: TMenuItem;
    Item111: TMenuItem;
    Item121: TMenuItem;
    m1Opcin31: TMenuItem;
    Modulo21: TMenuItem;
    Item211: TMenuItem;
    Item221: TMenuItem;
    Modulo31: TMenuItem;
    m3Opcin11: TMenuItem;
    m3Opcin21: TMenuItem;
    m3Opcin31: TMenuItem;
    Modulo41: TMenuItem;
    m4Opcin11: TMenuItem;
    m4Opcin21: TMenuItem;
    AVLock3Pro1: TAVLock3Pro;
    Image1: TImage;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    LUserName: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    LCompany: TLabel;
    procedure Registrar1Click(Sender: TObject);
    procedure Item111Click(Sender: TObject);
    procedure Item121Click(Sender: TObject);
    procedure m1Opcin31Click(Sender: TObject);
    procedure Item211Click(Sender: TObject);
    procedure Item221Click(Sender: TObject);
    procedure m3Opcin11Click(Sender: TObject);
    procedure m3Opcin21Click(Sender: TObject);
    procedure m3Opcin31Click(Sender: TObject);
    procedure m4Opcin11Click(Sender: TObject);
    procedure m4Opcin21Click(Sender: TObject);
    procedure Salir1Click(Sender: TObject);
    procedure Registration1Click(Sender: TObject);
    procedure Label1Click(Sender: TObject);
    procedure Label2Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    Procedure setmodules;
    function MyExecute(force:boolean):boolean;
    procedure legend(m,i:integer);
  end;

var
  Form1  : TForm1;

implementation
uses RegUnit;
{$R *.DFM}

Procedure TForm1.setmodules;
begin
  with avlock3pro1 do begin
    MM1.Items[1].visible := mods[1];
    MM1.Items[2].visible := mods[2];
    MM1.Items[3].visible := mods[3];
    MM1.Items[4].visible := mods[4];
    LUserName.caption:=UserName;
    LCompany.caption:=UserCompany;
  end;
end;

function TForm1.MyExecute(force:boolean):boolean;
var F:TRegForm;
    regcod,s:string;
    i,j:integer;
    mLabels: array[1..8] of TLabel;
begin
  Result:=False;
  with AVLock3Pro1 do begin
    readkey;
    if firsttime then maketrial;
    result:= ((Status=2)
      or ((Status=1) and (EndDate-date > DaysBeforeWarning) and not Expired));
    if result and not force then exit;
    F:=TRegForm.Create(nil);
    try
    F.Caption:=AppName;
    F.BtnOk.Enabled:=not expired;
    case Status of
      0:F.LStatus1.caption:='TRIAL';
      1:F.LStatus1.caption:='AUTHORIZED';
      2:F.LStatus1.caption:='REGISTERED';
    end;
    F.Panel1.Visible := showprogress and (Status<>2) and not expired;
    if expired then F.LStatus2.Caption:='Period expired'
    else F.LStatus2.Caption:='Remaining days '+inttostr(trunc(EndDate-date));
    F.LStatus2.visible:=(Status<>2);
    //for i:=1 to 8 do F.textmods[i]:=txtmods[i];
    j:=0;
    if AllowModules then with F do
    for i:=1 to 8 do begin
      mlabels[i]:=Tlabel.create(nil);
      if mods[i] then begin
        inc(j);
        mlabels[i].parent:=ScrollBox1;
        mlabels[i].left:=1;
        mlabels[i].top:=(j-1)*15+1;
        mlabels[i].caption:=TxtMods[i];
      end;
    end;
    F.Lreg.caption:='Registration Status';
    F.Lmodul.caption:='Allowed Modules';
    F.memo1.Clear;
    if (Status <> 2) then begin
      if (days=0) and (TrialMode=tmNone) then F.Memo1.lines.Add('To start with your free trial period please request your Registration Key.')
      else if expired then F.Memo1.lines.Add('Trial period expired!  If you want to continue using this program please register it.')
      else if (Date > EndDate-DaysBeforeWarning) then F.Memo1.lines.Add('Warning!  This program will be expiring shortly. If you want to continue using it please renew your registration.')
      else F.Memo1.lines.Add('Congratulations!!!  You are in the trial period of this program, enjoy it!');
    end;

    F.BtnCancel.Caption:='Cancel';
    F.BtnOk.Caption:='Continue >>';
    F.LDate0.Caption := datetostr(begindate);
    F.LDate1.Caption := datetostr(enddate);
    F.PBar1.Min :=0;
    F.PBar1.Max :=trunc(enddate-begindate);
    F.Pbar1.Position := trunc(date-begindate);

    F.PMod.Visible := AllowModules;

    F.ClientWidth:=F.btnRegNow.Left+F.btnRegNow.Width+12;
    F.ClientHeight:=F.Panel3.Top+F.Panel3.Height+5;
    F.AVLock1 := AVLock3Pro1;

    F.ShowModal;
    if F.modalresult = mrYes then begin
      regcod:=F.edreg.text;
      if verifykey(AppID,MachineCode,regcod) then begin
        writekey(regcod);
        readkey;
        showmessage('Registration successful');
        if not expired then Result:=True;
      end else showmessage('Invalid Registration Key');
      F.Panel1.Visible := showprogress and (Status<>2) and not expired;
    end;
    if (F.modalresult = mrOk) and not expired then Result:=True;
    finally
      if AllowModules then for i:=1 to 8 do mlabels[i].free;
      F.Free;
    end;
  end;
end;



procedure TForm1.legend(m,i:integer);
begin
  //added to avoid haking -------------------------
  avlock3pro1.check;
  //-----------------------------------------------
  showmessage('Module: '+avlock3pro1.txtmods[m]+'       Item: '+inttostr(i)+#13#10+
  '--------------------------------------------'+#13#10+
  'UserName  : '+avlock3pro1.UserName+#13+
  'Company   : '+avlock3pro1.Company+#13+
  '--------------------------------------------'+#13#10+
  'Sample program using the AVLock Pro component');
end;

procedure TForm1.Registrar1Click(Sender: TObject);
begin
  myexecute(true);
end;

procedure TForm1.Item111Click(Sender: TObject);
begin
  legend(1,1);
end;

procedure TForm1.Item121Click(Sender: TObject);
begin
  legend(1,2);
end;

procedure TForm1.m1Opcin31Click(Sender: TObject);
begin
  legend(1,3);
end;

procedure TForm1.Item211Click(Sender: TObject);
begin
  legend(2,1);
end;

procedure TForm1.Item221Click(Sender: TObject);
begin
  legend(2,2);
end;

procedure TForm1.m3Opcin11Click(Sender: TObject);
begin
  legend(3,1);
end;

procedure TForm1.m3Opcin21Click(Sender: TObject);
begin
  legend(3,2);
end;

procedure TForm1.m3Opcin31Click(Sender: TObject);
begin
  legend(3,3);
end;

procedure TForm1.m4Opcin11Click(Sender: TObject);
begin
  legend(4,1);
end;

procedure TForm1.m4Opcin21Click(Sender: TObject);
begin
  legend(4,2);
end;

procedure TForm1.Salir1Click(Sender: TObject);
begin
  Close;
end;

procedure TForm1.Registration1Click(Sender: TObject);
begin
  MyExecute(True);
end;

procedure TForm1.Label1Click(Sender: TObject);
begin
  ShellExecute(0, 'open',
  Pchar('https://secure.element5.com/shareit/checkout.html?productid=209900&language=English'),
  nil, nil, SW_SHOWMAXIMIZED);
end;

procedure TForm1.Label2Click(Sender: TObject);
begin
  ShellExecute(0, 'open',
  Pchar('https://secure.element5.com/shareit/checkout.html?productid=209901&language=English'),
  nil, nil, SW_SHOWMAXIMIZED);
end;

end.
